// Hlavicky
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>

// Definice
#define GRAFIKA		0 /**< Volba pro akci - bude spusten GUI */
#define	ENCODE		1 /**< Volba pro akci - bude spustena komprese */
#define	DECODE		2 /**< Volba pro akci - bude spustena dekomprese */
#define GUI_FILE	"main.glade" /**< Nazev souboru GUI hlavniho okna */
#define ABOUT_FILE	"about.glade" /**< Nazev souboru GUI About dialogu */
#define TIMEOUT		200 /**< Interval mereni rychlosti v ms */
#define VERZE		"v0.3 Raptor 2010" /**< Verze softwaru a nick */

// Struktury
/**
 * \brief Struktura obsahujici pointery na graficke prvky
 *
 * Pri obsluze GTK callbacku je potreba casto menit vlastnosti jinych prvku,
 * promennych a widgetu, nez toho, ktery callback vyvolal. Tato struktura
 * obsahuje pointery na vsechny promenne a widgety, se kterymi je treba
 * takto pracovat.
 */
typedef struct _ChData {
	GtkWidget *main_window; /**< Hlavni okno */
	GtkWidget *label_info; /**< Informacni label */
	GtkWidget *statusbar; /**< Statusbar */
	GtkWidget *textview_native; /**< Pole vyberu vystupniho souboru */
	GtkWidget *textview_hamming; /**< Tlacitko vyberu souboru vstupu */
	GtkTextBuffer *textbuffer1; /**< Retezec nazvu vstupniho souboru */
	GtkTextBuffer *textbuffer2; /**< Retezec nazvu vystupniho souboru */
} ChData;

// Globalni promenne
gint vypisy; /**< Uroven debug vypisu */
glong pro_merak; /**< Pro vypocet rychlosti - aktualni hodnota */
glong pro_merak_posledni; /**< Pro vypocet rychlosti - minula hodnota */
glong pro_merak_celkem; /**< Pro vypocet prubehu - celkova hodnota */
gint grafika; /**< Pri nenulove hodnote deaktivuje praci s grafikou */
GThread *thread; /**< Pointer na vlakno (pouzito pri (de)kompresi v GUI */
GError *err = NULL; /**< Chyby pri vytvareni vlakna */